package cn.com.infosec.crypto.generators;

import cn.com.infosec.crypto.AsymmetricCipherKeyPair;
import cn.com.infosec.crypto.AsymmetricCipherKeyPairGenerator;
import cn.com.infosec.crypto.KeyGenerationParameters;
import cn.com.infosec.crypto.params.ElGamalKeyGenerationParameters;
import cn.com.infosec.crypto.params.ElGamalParameters;
import cn.com.infosec.crypto.params.ElGamalPrivateKeyParameters;
import cn.com.infosec.crypto.params.ElGamalPublicKeyParameters;
import java.math.BigInteger;
import java.security.SecureRandom;

public class ElGamalKeyPairGenerator implements AsymmetricCipherKeyPairGenerator {
   private DHKeyGeneratorHelper helper;
   private ElGamalKeyGenerationParameters param;

   public ElGamalKeyPairGenerator() {
      this.helper = DHKeyGeneratorHelper.INSTANCE;
   }

   public void init(KeyGenerationParameters param) {
      this.param = (ElGamalKeyGenerationParameters)param;
   }

   public AsymmetricCipherKeyPair generateKeyPair() {
      ElGamalKeyPairGenerator var10000 = this;
      ElGamalParameters var1;
      BigInteger var2 = (var1 = this.param.getParameters()).getP();
      DHKeyGeneratorHelper var10001 = this.helper;
      SecureRandom var3 = this.param.getRandom();
      BigInteger var4 = var10001.calculatePrivate(var2, var3, var1.getL());
      var2 = var10000.helper.calculatePublic(var2, var1.getG(), var4);
      return new AsymmetricCipherKeyPair(new ElGamalPublicKeyParameters(var2, var1), new ElGamalPrivateKeyParameters(var4, var1));
   }
}
